diff --git a/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index d817112cb..acfbdbb35 100644
--- a/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -1,24 +1,21 @@
 package net.minecraft.client.render.entity;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.model.BaseModel;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
-
-// Referenced classes of package net.minecraft.src:
-//            Render, BaseModel, Mob, MathHelper,
-//            RenderManager, Tessellator, FontRenderer, Entity
+import org.slf4j.Logger;
 
 public class MobRenderer<T extends Mob> extends EntityRenderer<T>
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static final int MAX_ARMOR_LAYERS = 4;
     protected BaseModel mainModel;
     protected BaseModel armorModel;
@@ -150,7 +147,7 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
         }
         catch(Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Render exception in class '{}'!", getClass().getSimpleName(), exception);
         }
         GL11.glEnable(GL11.GL_CULL_FACE);
         GL11.glPopMatrix();
@@ -229,7 +226,7 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
         {
             return;
         }
-        final FontRenderer fontrenderer = getFontRenderer();
+        final Font font = getFont();
         final float f1 = 1.6F;
         final float f2 = 0.01666667F * f1;
         GL11.glPushMatrix();
@@ -246,7 +243,7 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
         byte byte0 = 0;
         GL11.glDisable(3553 /* GL_TEXTURE_2D */);
         tessellator.startDrawingQuads();
-        final int j = fontrenderer.getStringWidth(s) / 2;
+        final int j = font.getStringWidth(s) / 2;
         tessellator.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
         tessellator.addVertex(-j - 1, -1 + byte0, 0.0D);
         tessellator.addVertex(-j - 1, 8 + byte0, 0.0D);
@@ -254,10 +251,10 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
         tessellator.addVertex(j + 1, -1 + byte0, 0.0D);
         tessellator.draw();
         GL11.glEnable(3553 /* GL_TEXTURE_2D */);
-        fontrenderer.drawString(s, -fontrenderer.getStringWidth(s) / 2, byte0, 0x20ffffff);
+        font.drawString(s, -font.getStringWidth(s) / 2, byte0, 0x20ffffff);
         if (!depthTest) GL11.glEnable(2929 /* GL_DEPTH_TEST */);
         GL11.glDepthMask(true);
-        fontrenderer.drawString(s, -fontrenderer.getStringWidth(s) / 2, byte0, 0xFFFFFF);
+        font.drawString(s, -font.getStringWidth(s) / 2, byte0, 0xFFFFFF);
         GL11.glEnable(2896 /* GL_LIGHTING */);
         GL11.glDisable(3042 /* GL_BLEND */);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
diff --git a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
index 659b8a848..31d64760f 100644
--- a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
@@ -3,7 +3,7 @@ package net.minecraft.client.render.entity;
 import net.minecraft.client.Minecraft;
 
 import net.minecraft.client.entity.player.LocalPlayer;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.PlayerSkinParser;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
@@ -155,7 +155,7 @@ public class PlayerRenderer extends MobRenderer<Player>
                     }
                 } else
                 {
-                    FontRenderer fontrenderer = getFontRenderer();
+                    Font font = getFont();
                     GL11.glPushMatrix();
                     GL11.glTranslatef((float)d + 0.0F, (float)d1 + 2.3F, (float)d2);
                     GL11.glNormal3f(0.0F, 1.0F, 0.0F);
@@ -169,7 +169,7 @@ public class PlayerRenderer extends MobRenderer<Player>
                     GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
                     GL11.glDisable(GL11.GL_TEXTURE_2D);
                     tessellator.startDrawingQuads();
-                    int i = fontrenderer.getStringWidth(s) / 2;
+                    int i = font.getStringWidth(s) / 2;
                     tessellator.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
                     tessellator.addVertex(-i - 1, -1D, 0.0D);
                     tessellator.addVertex(-i - 1, 8D, 0.0D);
@@ -178,7 +178,7 @@ public class PlayerRenderer extends MobRenderer<Player>
                     tessellator.draw();
                     GL11.glEnable(GL11.GL_TEXTURE_2D);
                     GL11.glDepthMask(true);
-                    fontrenderer.drawString(s, -fontrenderer.getStringWidth(s) / 2, 0, 0x20ffffff);
+                    font.drawString(s, -font.getStringWidth(s) / 2, 0, 0x20ffffff);
                     GL11.glEnable(GL11.GL_LIGHTING);
                     GL11.glDisable(GL11.GL_BLEND);
                     GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
diff --git a/src/main/java/net/minecraft/client/render/item/model/BlockItemModel.java b/src/main/java/net/minecraft/client/render/item/model/BlockItemModel.java
index 9f16c0e72..fdea38f0b 100644
--- a/src/main/java/net/minecraft/client/render/item/model/BlockItemModel.java
+++ b/src/main/java/net/minecraft/client/render/item/model/BlockItemModel.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.ItemRenderer;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
@@ -101,7 +101,7 @@ public class BlockItemModel extends StandardItemModel {
         }
     }
     @Override
-    public void renderItemIntoGui(Tessellator tessellator, FontRenderer fontrenderer, RenderEngine renderengine, ItemStack itemStack, int x, int y, float brightness, float alpha) {
+    public void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemStack, int x, int y, float brightness, float alpha) {
         if (itemStack == null) return;
         GL11.glEnable(GL_BLEND);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
@@ -131,7 +131,7 @@ public class BlockItemModel extends StandardItemModel {
             BlockModel.renderBlocks.useInventoryTint = true;
             GL11.glPopMatrix();
         } else {
-            super.renderItemIntoGui(tessellator, fontrenderer, renderengine, itemStack, x, y, brightness, alpha);
+            super.renderItemIntoGui(tessellator, font, textureManager, itemStack, x, y, brightness, alpha);
         }
         GL11.glEnable(GL_CULL_FACE);
         GL11.glDisable(GL_BLEND);
diff --git a/src/main/java/net/minecraft/client/render/item/model/BowItemModel.java b/src/main/java/net/minecraft/client/render/item/model/BowItemModel.java
index 3ba604844..dda734c48 100644
--- a/src/main/java/net/minecraft/client/render/item/model/BowItemModel.java
+++ b/src/main/java/net/minecraft/client/render/item/model/BowItemModel.java
@@ -2,9 +2,9 @@ package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.player.RemotePlayer;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.ItemRenderer;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
@@ -47,7 +47,7 @@ public class BowItemModel extends StandardItemModel {
         }
     }
     @Override
-    public void renderItemIntoGui(Tessellator tessellator, FontRenderer fontrenderer, RenderEngine renderengine, ItemStack itemStack, int x, int y, float brightness, float alpha) {
+    public void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemStack, int x, int y, float brightness, float alpha) {
         Minecraft mc = Minecraft.getMinecraft(this);
         Item nextArrow = getNextArrow(mc.thePlayer);
         if (itemStack == mc.thePlayer.getHeldItem() && nextArrow != null){
@@ -72,7 +72,7 @@ public class BowItemModel extends StandardItemModel {
             glEnable(GL_CULL_FACE);
             glDisable(GL11.GL_BLEND);
         }
-        super.renderItemIntoGui(tessellator, fontrenderer, renderengine, itemStack, x, y, brightness, alpha);
+        super.renderItemIntoGui(tessellator, font, textureManager, itemStack, x, y, brightness, alpha);
     }
     public Item getNextArrow(Player player){
         if (player instanceof RemotePlayer){
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModel.java b/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
index 65013fe00..4bbbde18c 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.ItemRenderer;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
@@ -28,15 +28,15 @@ public abstract class ItemModel {
     }
     public abstract void renderItem(Tessellator tessellator, ItemRenderer renderer, ItemStack itemstack, @Nullable Entity entity, float brightness, boolean handheldTransform);
     public abstract void renderItemThirdPerson(Tessellator tessellator, ItemRenderer renderer, Entity entity, ItemStack itemstack, boolean handheldTransform);
-    public void renderItemIntoGui(Tessellator tessellator, FontRenderer fontrenderer, RenderEngine renderengine, ItemStack itemstack, int x, int y, float alpha) {
-        renderItemIntoGui(tessellator, fontrenderer, renderengine, itemstack, x, y, 1.0f, alpha);
+    public void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemstack, int x, int y, float alpha) {
+        renderItemIntoGui(tessellator, font, textureManager, itemstack, x, y, 1.0f, alpha);
     }
-    public abstract void renderItemIntoGui(Tessellator tessellator, FontRenderer fontrenderer, RenderEngine renderengine, ItemStack itemStack, int x, int y, float brightness, float alpha);
-    public void renderItemOverlayIntoGUI(Tessellator tessellator, FontRenderer fontrenderer, RenderEngine renderengine, ItemStack itemstack, int x, int y, float alpha) {
-        renderItemOverlayIntoGUI(tessellator, fontrenderer, renderengine, itemstack, x, y, null, alpha);
+    public abstract void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemStack, int x, int y, float brightness, float alpha);
+    public void renderItemOverlayIntoGUI(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemstack, int x, int y, float alpha) {
+        renderItemOverlayIntoGUI(tessellator, font, textureManager, itemstack, x, y, null, alpha);
     }
 
-    public abstract void renderItemOverlayIntoGUI(Tessellator tessellator, FontRenderer fontrenderer, RenderEngine renderengine, ItemStack itemstack, int x, int y, String override, float alpha);
+    public abstract void renderItemOverlayIntoGUI(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemstack, int x, int y, String override, float alpha);
     public abstract void renderAsItemEntity(Tessellator tessellator, @Nullable Entity entity, Random random, ItemStack itemstack, int renderCount, float yaw, float brightness, float partialTick);
     public abstract void renderItemInWorld(Tessellator tessellator, Entity entity, ItemStack itemStack, float brightness, float alpha, boolean worldTransform);
     public abstract IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack);
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
index 47b371ccb..655d998ca 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.ItemRenderer;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
@@ -33,12 +33,12 @@ public class ItemModelNone extends ItemModel{
     }
 
     @Override
-    public void renderItemIntoGui(Tessellator tessellator, FontRenderer fontrenderer, RenderEngine renderengine, ItemStack itemStack, int x, int y, float brightness, float alpha) {
+    public void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemStack, int x, int y, float brightness, float alpha) {
 
     }
 
     @Override
-    public void renderItemOverlayIntoGUI(Tessellator tessellator, FontRenderer fontrenderer, RenderEngine renderengine, ItemStack itemstack, int x, int y, String override, float alpha) {
+    public void renderItemOverlayIntoGUI(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemstack, int x, int y, String override, float alpha) {
 
     }
 
diff --git a/src/main/java/net/minecraft/client/render/item/model/MapItemModel.java b/src/main/java/net/minecraft/client/render/item/model/MapItemModel.java
index b2b99f46b..85de3d540 100644
--- a/src/main/java/net/minecraft/client/render/item/model/MapItemModel.java
+++ b/src/main/java/net/minecraft/client/render/item/model/MapItemModel.java
@@ -26,7 +26,7 @@ import org.lwjgl.opengl.GL12;
 
 public class MapItemModel extends StandardItemModel {
     private final Minecraft mc = Minecraft.getMinecraft(Minecraft.class);
-    private final MapItemRenderer renderMapInstance = new MapItemRenderer(mc.fontRenderer, mc.gameSettings, mc.renderEngine);
+    private final MapItemRenderer renderMapInstance = new MapItemRenderer(mc.font, mc.gameSettings, mc.textureManager);
 
     public MapItemModel(Item item, String namespace) {
         super(item, namespace);
@@ -64,7 +64,7 @@ public class MapItemModel extends StandardItemModel {
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
         // Render both player arms
-        mc.renderEngine.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
+        mc.textureManager.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
         PlayerRenderer playerRenderer = (PlayerRenderer) (EntityRenderer<? extends Entity>) EntityRenderDispatcher.instance.getRenderer(mc.thePlayer);
 
         GL11.glPushMatrix();
@@ -102,7 +102,7 @@ public class MapItemModel extends StandardItemModel {
         GL11.glNormal3f(0.0F, 0.0F, -1F);
 
         // Render paper background of map
-        mc.renderEngine.bindTexture(mc.renderEngine.loadTexture("/assets/minecraft/textures/misc/mapbg.png"));
+        mc.textureManager.bindTexture(mc.textureManager.loadTexture("/assets/minecraft/textures/misc/mapbg.png"));
         tessellator.startDrawingQuads();
         final byte expansion = 7; // makes the edges extend around the actual map data by a bit
         tessellator.addVertexWithUV(-expansion,     128 + expansion, 0.0D, 0.0D, 1.0D);
@@ -113,7 +113,7 @@ public class MapItemModel extends StandardItemModel {
 
         ItemMapSavedData mapData = Items.MAP.getOrCreateSavedData(stack, mc.theWorld);
         if (mapData == null) return;
-        renderMapInstance.renderMap(mc.renderEngine, mapData, brightness);
+        renderMapInstance.renderMap(mc.textureManager, mapData, brightness);
     }
     @Override
     public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
diff --git a/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java b/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java
index ff5bf5749..568cf2247 100644
--- a/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java
+++ b/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java
@@ -2,10 +2,10 @@ package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.EntityRenderDispatcher;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.ItemRenderer;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -133,7 +133,7 @@ public class StandardItemModel extends ItemModel{
     }
 
     @Override
-    public void renderItemIntoGui(Tessellator tessellator, FontRenderer fontrenderer, RenderEngine renderengine, ItemStack itemStack, int x, int y, float brightness, float alpha) {
+    public void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemStack, int x, int y, float brightness, float alpha) {
         if (itemStack == null) return;
         Minecraft mc = Minecraft.getMinecraft(this);
         glEnable(GL_BLEND);
@@ -158,7 +158,7 @@ public class StandardItemModel extends ItemModel{
     }
 
     @Override
-    public void renderItemOverlayIntoGUI(Tessellator tessellator, FontRenderer fontrenderer, RenderEngine renderengine, ItemStack itemstack, int x, int y, String override, float alpha) {
+    public void renderItemOverlayIntoGUI(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemstack, int x, int y, String override, float alpha) {
         glEnable(GL_BLEND);
         glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         if (itemstack == null) {
@@ -169,7 +169,7 @@ public class StandardItemModel extends ItemModel{
             String s = override != null ? override : "" + itemstack.stackSize;
             GL11.glDisable(GL_LIGHTING);
             GL11.glDisable(GL_DEPTH_TEST);
-            fontrenderer.drawStringWithShadow(s, (x + 19) - 2 - fontrenderer.getStringWidth(s), y + 6 + 3, 0xffffff | (a << 24));
+            font.drawStringWithShadow(s, (x + 19) - 2 - font.getStringWidth(s), y + 6 + 3, 0xffffff | (a << 24));
             GL11.glEnable(GL_LIGHTING);
             GL11.glEnable(GL_DEPTH_TEST);
         }
diff --git a/src/main/java/net/minecraft/client/render/shader/PhotoModeRenderer.java b/src/main/java/net/minecraft/client/render/shader/PhotoModeRenderer.java
index 77e4786c5..0c5c34dde 100644
--- a/src/main/java/net/minecraft/client/render/shader/PhotoModeRenderer.java
+++ b/src/main/java/net/minecraft/client/render/shader/PhotoModeRenderer.java
@@ -1,20 +1,20 @@
 package net.minecraft.client.render.shader;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiPhotoMode;
+import net.minecraft.client.gui.PhotoModeScreen;
 
 public class PhotoModeRenderer extends ShadersRenderer {
 
 	public static final String[] shaders = new String[] { null, "blur", "silhouette", "vignette", "tiltshift", "outline", "outline2", "eerie", "sepia", "inverted", "distantblur" };
 
-	public final GuiPhotoMode guiPhotoMode;
+	public final PhotoModeScreen screen;
 
 	private int selectedShader = 0;
 
-	public PhotoModeRenderer(Minecraft minecraft, GuiPhotoMode guiPhotoMode) {
+	public PhotoModeRenderer(Minecraft minecraft, PhotoModeScreen screen) {
 		super(minecraft);
 
-		this.guiPhotoMode = guiPhotoMode;
+		this.screen = screen;
 		
 		if(!Shaders.enableShaders) throw new RuntimeException("Shaders disabled!");
 	}
diff --git a/src/main/java/net/minecraft/client/render/shader/Shader.java b/src/main/java/net/minecraft/client/render/shader/Shader.java
index 8fa88bf29..6a9af19cc 100644
--- a/src/main/java/net/minecraft/client/render/shader/Shader.java
+++ b/src/main/java/net/minecraft/client/render/shader/Shader.java
@@ -6,10 +6,12 @@ import static org.lwjgl.opengl.GL20.*;
 import java.util.HashMap;
 import java.util.Map;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.OpenGLHelper;
+import org.slf4j.Logger;
 
 public class Shader {
-	
+	private static final Logger LOGGER = LogUtils.getLogger();
 	private int program;
 	
 	private int vertexShader;
@@ -45,15 +47,15 @@ public class Shader {
 		int vertexShaderCompileStatus = glGetShaderi(vertexShader, GL_COMPILE_STATUS);
 		
 		if(fragmentShaderCompileStatus != GL_TRUE || vertexShaderCompileStatus != GL_TRUE) {
-			System.err.println("Shader "+name+" compile error");
+            LOGGER.error("Shader {} compile error", name);
 			
 			if(vertexShaderCompileStatus != GL_TRUE) {
-				System.err.println("Vertex Shader Info Log:");
-				System.err.println(glGetShaderInfoLog(vertexShader, glGetShaderi(vertexShader, GL_INFO_LOG_LENGTH)));
+				LOGGER.error("Vertex Shader Info Log:");
+				LOGGER.error(glGetShaderInfoLog(vertexShader, glGetShaderi(vertexShader, GL_INFO_LOG_LENGTH)));
 			}
 			if(fragmentShaderCompileStatus != GL_TRUE) {
-				System.err.println("Vertex Shader Info Log:");
-				System.err.println(glGetShaderInfoLog(fragmentShader, glGetShaderi(fragmentShader, GL_INFO_LOG_LENGTH)));
+				LOGGER.error("Vertex Shader Info Log:");
+				LOGGER.error(glGetShaderInfoLog(fragmentShader, glGetShaderi(fragmentShader, GL_INFO_LOG_LENGTH)));
 			}
 			
 			delete();
@@ -69,8 +71,8 @@ public class Shader {
 		
 		int programLinkStatus = glGetProgrami(program, GL_LINK_STATUS);
 		if(programLinkStatus != GL_TRUE) {
-			System.err.println("Program Link Error: ");
-			System.err.println(glGetProgramInfoLog(program, glGetProgrami(program, GL_INFO_LOG_LENGTH)));
+			LOGGER.error("Program Link Error: ");
+			LOGGER.error(glGetProgramInfoLog(program, glGetProgrami(program, GL_INFO_LOG_LENGTH)));
 			
 			delete();
 			return this;
diff --git a/src/main/java/net/minecraft/client/render/shader/ShaderProviderExternal.java b/src/main/java/net/minecraft/client/render/shader/ShaderProviderExternal.java
index 27c535350..d6e45a2cd 100644
--- a/src/main/java/net/minecraft/client/render/shader/ShaderProviderExternal.java
+++ b/src/main/java/net/minecraft/client/render/shader/ShaderProviderExternal.java
@@ -3,10 +3,12 @@ package net.minecraft.client.render.shader;
 import java.io.File;
 
 import com.b100.utils.StringUtils;
+import com.mojang.logging.LogUtils;
+import org.slf4j.Logger;
 
 public class ShaderProviderExternal implements ShaderProvider {
-	
-	private File dir;
+	private static final Logger LOGGER = LogUtils.getLogger();
+	private final File dir;
 	
 	public ShaderProviderExternal(File dir) {
 		this.dir = dir;
@@ -16,13 +18,13 @@ public class ShaderProviderExternal implements ShaderProvider {
 	public String getShaderSource(String name) {
 		File file = new File(dir, name);
 		if(!file.exists()) {
-			System.err.println("File " + file.getAbsolutePath() + " does not exist!");
+            LOGGER.error("File {} does not exist!", file.getAbsolutePath());
 			return null;
 		}
 		try {
 			return StringUtils.getFileContentAsString(file);
 		}catch (Exception e) {
-			e.printStackTrace();
+            LOGGER.error("Exception reading shader file '{}'!", file.getPath(), e);
 			return null;
 		}
 	}
diff --git a/src/main/java/net/minecraft/client/render/shader/ShaderProviderInternal.java b/src/main/java/net/minecraft/client/render/shader/ShaderProviderInternal.java
index 48d30d673..da6097a29 100644
--- a/src/main/java/net/minecraft/client/render/shader/ShaderProviderInternal.java
+++ b/src/main/java/net/minecraft/client/render/shader/ShaderProviderInternal.java
@@ -3,10 +3,12 @@ package net.minecraft.client.render.shader;
 import java.io.InputStream;
 
 import com.b100.utils.StringUtils;
+import com.mojang.logging.LogUtils;
+import org.slf4j.Logger;
 
 public class ShaderProviderInternal implements ShaderProvider {
-
-	private String dir;
+	private static final Logger LOGGER = LogUtils.getLogger();
+	private final String dir;
 	
 	public ShaderProviderInternal(String dir) {
 		this.dir = dir;
@@ -15,24 +17,18 @@ public class ShaderProviderInternal implements ShaderProvider {
 	@Override
 	public String getShaderSource(String name) {
 		String path = dir + name;
-		
-		InputStream stream = null;
-		try {
-			stream = ShaderProviderInternal.class.getResourceAsStream(dir + name);
-			if(stream != null) {
-				return StringUtils.readInputString(stream);
-			}else {
-				System.err.println("Resource " + path + " does not exist!");
-				return null;
-			}
-		} catch (Exception e) {
-			e.printStackTrace();
-			return null;
-		} finally {
-			try {
-				stream.close();
-			}catch (Exception e) {}
-		}
+
+        try (InputStream stream = ShaderProviderInternal.class.getResourceAsStream(dir + name)) {
+            if (stream != null) {
+                return StringUtils.readInputString(stream);
+            } else {
+                LOGGER.error("Resource {} does not exist!", path);
+                return null;
+            }
+        } catch (Exception e) {
+            LOGGER.error("Exception reading shader resource '{}{}'!", dir, name, e);
+            return null;
+        }
 	}
 
 }
diff --git a/src/main/java/net/minecraft/client/render/shader/Shaders.java b/src/main/java/net/minecraft/client/render/shader/Shaders.java
index b30f7540f..7ad75a21e 100644
--- a/src/main/java/net/minecraft/client/render/shader/Shaders.java
+++ b/src/main/java/net/minecraft/client/render/shader/Shaders.java
@@ -4,7 +4,7 @@ package net.minecraft.client.render.shader;
 import static org.lwjgl.opengl.GL11.*;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiPhotoMode;
+import net.minecraft.client.gui.PhotoModeScreen;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.core.block.material.Material;
 
@@ -103,12 +103,12 @@ public abstract class Shaders {
 			shader.uniformFloat("gMod", 1.0f);
 			shader.uniformFloat("bMod", 1.0f);
 		}
-		shader.uniformFloat("photoMode", minecraft.currentScreen instanceof GuiPhotoMode);
+		shader.uniformFloat("photoMode", minecraft.currentScreen instanceof PhotoModeScreen);
 		shader.uniformFloat("guiOpened", minecraft.currentScreen != null);
 		
-		if(minecraft.currentScreen instanceof GuiPhotoMode) {
-			GuiPhotoMode guiPhotoMode = (GuiPhotoMode) minecraft.currentScreen;
-			shader.uniformFloat("intensity", guiPhotoMode.intensityValue);
+		if(minecraft.currentScreen instanceof PhotoModeScreen) {
+			PhotoModeScreen photoModeScreen = (PhotoModeScreen) minecraft.currentScreen;
+			shader.uniformFloat("intensity", photoModeScreen.intensityValue);
 		}else {
 			shader.uniformFloat("intensity", 1.0f);
 		}
diff --git a/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java b/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
index 8f1773f20..08f607cab 100644
--- a/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
+++ b/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
@@ -10,6 +10,7 @@ import java.nio.ByteBuffer;
 import java.nio.ByteOrder;
 import java.nio.FloatBuffer;
 
+import com.mojang.logging.LogUtils;
 import org.lwjgl.util.vector.Matrix4f;
 
 import net.minecraft.client.Minecraft;
@@ -20,9 +21,10 @@ import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.material.Material;
+import org.slf4j.Logger;
 
 public class ShadersRenderer implements Renderer {
-
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public Minecraft mc;
 	
 	protected final Framebuffer worldFramebuffer = new Framebuffer();
@@ -216,8 +218,8 @@ public class ShadersRenderer implements Renderer {
 			
 			boolean filtering = mc.gameSettings.renderScale.value.useLinearFiltering;
 			int filterMode = filtering ? GL_LINEAR : GL_NEAREST;
-			
-			System.out.println("Display: "+fbWidth+" x "+fbHeight+", Render: "+renderWidth+" x "+renderHeight);
+
+            LOGGER.info("Display: {} x {}, Render: {} x {}", fbWidth, fbHeight, renderWidth, renderHeight);
 			
 			worldFramebuffer.bind();
 
@@ -259,7 +261,7 @@ public class ShadersRenderer implements Renderer {
 		}
 	}
 	public void reload() {
-		System.out.println("Reloading Shaders...");
+		LOGGER.info("Reloading Shaders...");
 
 		glUseProgram(0);
 		glBindFramebuffer(GL_FRAMEBUFFER, 0);
@@ -299,7 +301,7 @@ public class ShadersRenderer implements Renderer {
 	
 	public ShaderProvider getShader() {
 		String override = mc.gameSettings.shaderOverride.value;
-		if(override != null && override.length() > 0) {
+		if(override != null && !override.isEmpty()) {
 			return new ShaderProviderExternal(new File(Global.accessor.getMinecraftDir(), "shaders/" + override));
 		}else {
 			return internal;
